/******************************* cgmext.c ***********************************/

#include <stdio.h>

#include "cgmasm.h"
#include "cgm.h"

void cgm1real(int op,FIXED p)
{
    int *ptr, buf[3];
    ptr = (int *) &p;
    buf[0] = op + 4;
    buf[1] = ptr[1]; /* whole */                        
    buf[2] = ptr[0]; /* fraction */
    cgm_swab(3,buf);
    fwrite(buf,2,3,_cgmout);        /* write element */
}

int cgmp1str(int op,int p1,int count,char *string)
{
    int temp,buf[3],j;
    if (count > 4096 )  return (0);
    temp = count;
    if (count > 254) temp += 2;
    if(temp > 27)
    {
       buf[0] =  op | 31;
       buf[1] =  temp + 3;
       j = 2;
    }
    else
    {
       buf[0] = op | (temp + 3);
       j = 1;
    }
    if ( !(count & 0x0001))
       temp++;

    buf[j++] = p1;
    cgm_swab(j,buf);
    fwrite(buf,2,j,_cgmout);            /* write text element */
    if( count <= 254) 
       fwrite(&count,1,1,_cgmout);          /* write number of chars in string */
    else
    {
       j = count;
       temp -= 2;
       cgm_swab(1,&j);
       count = 255;
       fwrite(&count,1,1,_cgmout);          /* write number of chars in string */
       fwrite(buf,2,1,_cgmout);            /* write text element */
    }
    fwrite(string,1,temp,_cgmout);       /* write string, if extra
                                              last char = str triminator (0) */
    return(1);  
}


/* data in array will be byte swapped (swab) on return */
/* num = number of vertices */
/* number of elements in array = 3*num */
/* array[3*(num -1) + 0]    =  x(num) */
/* array[3*(num -1) + 1]    =  y(num) */
/* array[3*(num -1) + 2]    =  Edge_Out_Flag(num + 1) */
/* flag           definition      */
/*  0                invisible    */
/*  1                visible      */
/*  2             close invisible */
/*  3             close visible   */

void cgm_polygon_set(int num, int *array)
{
   int temp,buf[2];

   temp = 3*num;
   buf[0] =  POLYGONSET | 31;
   buf[1] =  6*num;
   cgm_swab(2,buf);
   fwrite(buf,2,2,_cgmout); 
   cgm_swab(temp,array);
   fwrite(array,2,temp,_cgmout); 
}


void cgm_gdp(int id,int numpt,int *plist,int numchr,char *data)
{
   int buf[4],temp;
   temp = 4 + 4*numpt;
   if ( numchr >= 0)
   {
       if (numchr > 254)
          temp += 3 + numchr;
       else
          temp += 1 + numchr;
   }
   buf[0] = GDP | 31;
   buf[1] = temp;
   buf[2] = id;
   buf[3] = numpt;
   cgm_swab(4,buf);
   fwrite(buf,2,4,_cgmout);
   cgm_swab(2*numpt,plist);
   fwrite(plist,2,2*numpt,_cgmout);

   if (numchr > 254)
   {
      buf[0] = 255;
      fwrite(buf,1,1,_cgmout);
      buf[0] = numchr;
      cgm_swab(1,buf);
      fwrite(buf,2,1,_cgmout);
   }
   else
   { 
      buf[0] = numchr;
      fwrite(buf,1,1,_cgmout);
   }
   if(temp & 0x0001)
      numchr++;
   fwrite(data,1,numchr,_cgmout);
}
