/********************************** chkcgm.c ********************************/



#include <string.h>
#include <dir.h>
#include <stdio.h>
#include <stdlib.h>
#include "cgmparse.h"
#include "chkcgm.h"


FILE *out = NULL;  /* output file pointer */

int state = 1;     /* parser state */
int noop = 0;
int verbose;       /* verbose flag */
int hex;           /* hexidecimal flag */
int PicN = -1;     /* One Picture */

/* metafile element list flags */

int t0[MAXCLASS0ID +1];
int t1[MAXCLASS1ID +1];
int t2[MAXCLASS2ID +1];
int t3[MAXCLASS3ID +1];
int t4[MAXCLASS4ID +1];
int t5[MAXCLASS5ID +1];
int t6[MAXCLASS6ID +1];
int t7[MAXCLASS7ID +1];



char *copyright =
"CHKCGM v1.3  by  Robert M. Crawford";

char *address =
"1075 Elsie Mae Drive, Boulder Creek CA 95006";

char *syntax =
"Syntax is: chkcgm [options] source [output]";

char *options [][2] = {
"-v     ","Verbose",
"-h     ","Display Escape and Aplication Data in Hex",
"-a     ","Display Arts & Letters v1.2 metafiles",
"-p##   ","Only Output Picture ##",

NULL,NULL};


int cdecl main(int argc, char *argv[])
{

   char drive[MAXDRIVE];
   char dir[MAXDIR];
   char file[MAXFILE];
   char ext[MAXEXT];
   char s[MAXPATH];
   unsigned int partest;
   int koption,j;
   char *cpar;

   /* clear metafile element flags */
   for ( j = 0; j <= MAXCLASS0ID; j++) t0[j] = 0;
   for ( j = 0; j <= MAXCLASS1ID; j++) t1[j] = 0;
   for ( j = 0; j <= MAXCLASS2ID; j++) t2[j] = 0;
   for ( j = 0; j <= MAXCLASS3ID; j++) t3[j] = 0;
   for ( j = 0; j <= MAXCLASS4ID; j++) t4[j] = 0;
   for ( j = 0; j <= MAXCLASS5ID; j++) t5[j] = 0;
   for ( j = 0; j <= MAXCLASS6ID; j++) t6[j] = 0;
   for ( j = 0; j <= MAXCLASS7ID; j++) t7[j] = 0;

   verbose = 0; /* default is off */
   hex = 0;     /* default is off */
   partest = 0;
   cpar = argv[partest + 1];

   printf("%s\n",copyright);
   printf("%s\n\n",address);

   /* check for command line options */
   while( *cpar == '-')
   {
       partest++;
       cpar++;
       switch (*cpar)
       {

       case 'v' :
       case 'V' :
           cpar++;
           verbose = 1;
           break;

       case 'p' :
       case 'P' :
           cpar++;
           PicN = atoi(cpar);
           if( (PicN < 1) || (PicN > 99) ) PicN = -1;

           break;


       case 'h' :
       case 'H' :
           cpar++;
           hex = 1;
           break;

       case 'a' :
       case 'A' :
           cpar++;
           Arts = 1;
           break;

       default:

            printf(" Incorrect Switch -? ");
            return(1);
       }
       cpar = argv[partest + 1];
   }



   if (argc < (partest + 2) )
   { /* no files, list syntax and options */
      printf(" %s\n\n",syntax);
      for ( koption = 0; options[koption][0] != NULL; koption++)
      {
            printf(" %s  %s\n",options[koption][0],options[koption][1]);
      }
      return(0);
   }

   /* open the source file */
   fnsplit(argv[partest + 1],drive,dir,file,ext);

   if (ext[0] == '\0')
      strcpy(ext,".cgm");
   fnmerge(s,drive,dir,file,ext);
   cgmsrc = fopen(s,"rb");
   if (cgmsrc == NULL)
   {
      printf(" Source File %s%s Not Found\n",file,ext);
      return(1);
   }

   /* increase file buffer size */
   if ( setvbuf(cgmsrc,NULL,_IOFBF,10000) != 0)
   {
      printf("Out of Memory, Aborting");
      return(1);
   }
   
   
  /* check if source is a cgm metafile. */
  /* class = 0, id = 1 first element */

  cgm_read_element_header();

  if ((cgm_header.class == 0) && (cgm_header.id == 0))
  { /* check if no op at beginning of metafile*/
      noop = cgm_header.length;
      cgm_skipdata();  
      cgm_read_element_header();
  }
   
  if ((cgm_header.class == 0) && (cgm_header.id == 1))
  { /* it's a metafile, open output file */

      if (argc > (partest + 2) )
      { /* output file in command line */
          fnsplit(argv[partest + 2],drive,dir,file,ext);
          if (ext[0] == '\0')
          strcpy(ext,".log");
      }
      else
      { /* make output from input */
          strcpy(ext,".log");     
      }
      fnmerge(s,drive,dir,file,ext);
      out = fopen(s,"w");

      if (out == NULL)
      {
         fclose(cgmsrc);
         printf(" Output File %s%s Cannot be Opened\n",file,ext);
         return(1);
      }

      /* increase file buffer size */
      if ( setvbuf(out,NULL,_IOFBF,10000) != 0)
      {
         printf("Out of Memory, Aborting");
         return(1);
      }
      if(noop)
      {
         fprintf(out,"NO-OP [%d bytes]",noop);
      }
      cgm_pars01();
      cgm_skipdata();
  }
  else
  {   /* not a metafile */   
      printf("File %s%s not a CGM file\n",file,ext);
      fclose(cgmsrc);
      return(0);
  }  

  /* looks like a good cgm file so far, start parsing*/


   cgm_read_element_header();
   cgm_done = 0;
   while( !cgm_done && !ferror(cgmsrc) && !feof(cgmsrc) && !cgm_parse_error)
   {
       switch (cgm_header.class)
       {
          case 0:
          case 1:
                 cgm_pars01();
                 break;
          case 2:
          case 3:
                 cgm_pars23();
                 break;
          case 4:
                 cgm_pars4();
                 break;
          case 5:
                 cgm_pars5();
                 break;

          case 6:
          case 7:
                 cgm_pars67();
                 break;
          default:
                 fprintf(out,
                 "\n Element Class out of range (%d)\n",cgm_header.class);
             
       }
       if (!cgm_done)
              if(!cgm_skipdata() )  cgm_done = 1;
       if (!cgm_done)  cgm_read_element_header();
   }

   fclose(cgmsrc);
   if(cgm_parse_error)
   {
      printf("\n Parsing Error(s) Encountered");
      fprintf(out,"\n Parsing Error(s) Encountered");
   }
   fclose(out);
   return(0);
}

int set_look_up(int class, int id)
{ /* sets metafile elements list flag */
   int j;
    switch (class)
    {
    case -1:
              /* drawing Plus control set */
              for(j = 0; j <= MAXCLASS0ID; j++) t0[j] = 1;
              for(j = 1; j <= MAXCLASS1ID; j++) t1[j] = 1;
              for(j = 1; j <= MAXCLASS2ID; j++) t2[j] = 1;
              for(j = 1; j <= MAXCLASS3ID; j++) t3[j] = 1;
              for(j = 1; j <= MAXCLASS4ID; j++) t4[j] = 1;
              for(j = 1; j <= MAXCLASS5ID; j++) t5[j] = 1;
              for(j = 1; j <= MAXCLASS6ID; j++) t6[j] = 1;
              for(j = 1; j <= MAXCLASS7ID; j++) t7[j] = 1;
              if ( id == 0)
              {  /* remove control set */

                 t1[4] = 0;
                 t1[5] = 0;
                 t1[6] = 0;
                 t1[7] = 0;
                 t1[9] = 0;
                 t1[10] = 0;
                 t1[12] = 0;
                 t1[13] = 0;
                 t1[14] = 0;
                 t1[15] = 0;

                 t2[1] = 0;
                 t2[3] = 0;
                 t2[4] = 0;
                 t2[5] = 0;

                 t3[1] = 0;
                 t3[2] = 0;

                 t5[19] = 0;
                 t5[20] = 0;

              }

              break;
    case 0:
              if ( (id > -1) && (id <= MAXCLASS0ID) )
                 t0[id] = 1;
              else
                 return(0);
              break;
    case 1:

              if ( (id > 0) && (id <= MAXCLASS1ID) )
                 t1[id] = 1;
              else
                 return(0);

              break;
    case 2:

              if ( (id > 0) && (id <= MAXCLASS2ID) )
                 t2[id] = 1;
              else
                 return(0);

              break;
    case 3:
              if ( (id > 0) && (id <= MAXCLASS3ID) )
                 t3[id] = 1;
              else
                 return(0);


              break;
    case 4:
              if ( (id > 0) && (id <= MAXCLASS4ID) )
                 t4[id] = 1;
              else
                 return(0);

              break;
    case 5:

              if ( (id > 0) && (id <= MAXCLASS5ID) )
                 t5[id] = 1;
              else
                 return(0);

              break;
    case 6:

              if ( (id > 0) && (id <= MAXCLASS6ID) )
                 t6[id] = 1;
              else
                 return(0);

              break;
    case 7:

              if ( (id > 0) && (id <= MAXCLASS7ID) )
                 t7[id] = 1;
              else
                 return(0);

              break;
    default:
       return(0);
    }
    return(1);
}





int get_look_up(int class, int id)
{  /* returns 1 if metafile element list flage is set, else returns 0 */
    switch (class)
    {
    case 0:
              if ( (id > -1) && (id <= MAXCLASS0ID) && (t0[id] == 1) )
                 return(1);
              break;
    case 1:

              if ( (id > -1) && (id <= MAXCLASS1ID) && (t1[id] == 1) )
                 return(1);
              break;

    case 2:

              if ( (id > -1) && (id <= MAXCLASS2ID) && (t2[id] == 1) )
                 return(1);
              break;

    case 3:

              if ( (id > -1) && (id <= MAXCLASS3ID) && (t3[id] == 1) )
                 return(1);
              break;

    case 4:

              if ( (id > -1) && (id <= MAXCLASS4ID) && (t4[id] == 1) )
                 return(1);
              break;

    case 5:

              if ( (id > -1) && (id <= MAXCLASS5ID) && (t5[id] == 1) )
                 return(1);
              break;


    case 6:
              if ( (id > -1) && (id <= MAXCLASS6ID) && (t6[id] == 1) )
                 return(1);
              break;


    case 7:
              if ( (id > -1) && (id <= MAXCLASS7ID) && (t7[id] == 1) )
                 return(1);
              break;

          
    }
    return(0);
}
