/********************************** pars01.c ********************************/

#include <stdio.h>
#include <process.h>
#include "cgmparse.h"
#include "chkcgm.h"

static char *blen = "<<* Too Few Bytes *>>";
static char *nsup = "<<* Not Supported *>>";
static char *badstate = "<<* Bad State *>>";
static char *badvalue = "<<* Unknown Value *>>";
static char *mathtype[] = {"Integer","Real"}; 
static char *realtype[] = {"Floating Point","Fixed Point"}; 
static char *charsettype[] = {"94-character G-set","96-character G-set",
                              "94-character multibyte G-set",
                               "96-character multibyte G-set",
                               "Complete Code"};


static char *charcoding[] = { "Basic 7-bit","Basic 8-bit",
                               "Extended 7-bit","Extended 8-bit"};
static char *badel = "<<* Unknown Element *>>";

int mfList = 0;
int Arts = 0;
char *Class0[] = { "No-op",
                   "Begin Metafile ",
                   "End Metafile",
                   "Begin Picture ",
                   "Begin Picture Body",
                   "End Picture"
                 };

char *Class1[] = { "<<* Unknown ID *>>",                 
                   "Metafile Version",
                   "Metafile Description ",
                   "VDC Type",
                   "Integer Precision",
                   "Real Precision",
                   "Index Precision",
                   "Color Precision",
                   "Color Index Precision",
                   "Maximum Color Index",
                   "Color Value Extent",
                   "Metafile Elements List",
                   "Metafile Defaults Replacement",
                   "Font List",
                   "Character Set List",
                   "Character Coding Announcer"
                 };



static int gotoPicN(int PicN)
{
   int done, k;
   cgm_read_element_header();
   done = 0;
   k = 1; /* init to pic 1 */
   while( !done && !ferror(cgmsrc) && !feof(cgmsrc) && !cgm_parse_error)
   {
       if(cgm_header.class == 0)
       {
          if( cgm_header.id == 3)
          {
              k++;
              if( k == PicN) return(k);
          }
          else if(cgm_header.id == 2) done = 1;

       }
       if (!done)
              if(!cgm_skipdata() )  done = 1;
       if (!cgm_done)  cgm_read_element_header();
   }

   return(-1);

}


static void el_list(int class,int id ,int min,int max ,char *list[])
{/* output metafile Element (class,id). */
 /* If  min <= id <= max  list[id] is output, */
 /* else bad element message is output. */

   if ( (id >= min) && (id <= max) )
      fprintf(out,"\n    %s",list[id]);
   else
      fprintf(out,"\n    %s  (%d,%d)",badel,class,id);
}


void cgm_pars01(void)
{
    int p1,p2,p3,p4,rgb[3];
    if(cgm_header.class == 0)
    {
        if ( (cgm_header.id <= MAXCLASS0ID) && (cgm_header.id > -1 ) )
            fprintf(out,"\n%s",Class0[cgm_header.id]);
        else
            fprintf(out,
            "\n    %s  (%d,%d)",badel,cgm_header.class,cgm_header.id);


        switch (cgm_header.id)
        {
             case 0:  /* No-Op */                            
                       break;
             case 1:  /*Begin Metafile*/
      
                     if(state != 1)
                        fprintf(out," %s (%d)",badstate,state);
                     state = 2;

                     if( cgm_header.length < 1)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }
                     if(Arts)
                     {
                         cgm_header.length--;
                         fprintf(out," \"Arts & Letters v1.2\"");

                         break;
                     }
                     cgm_read_string();
                     fprintf(out," \"%s\"",cgm_cbuffer);
                     break;

             case 2:  /*End Metafile*/

                     if(state != 5)
                        fprintf(out," %s (%d)",badstate,state);
                     state = 1;
                     cgm_done = 1;
                     break;

             case 3: /*Begin Picture*/
                     LineScaleMode = 1;
                     EdgeScaleMode = 1;
                     MarkerScaleMode =1;

                     if( (state != 2) && (state != 5))
                         fprintf(out," %s (%d)",badstate,state);
                     state = 3;         
                     if( cgm_header.length < 1)
                     {
                         fprintf(out," %s",blen);
                        if(mfList == 0)
                        fprintf(out,"\n << Missing Metafile Element List >>\n");

                         break;
                     }

                     if(PicN > 1)
                     {  /* skip to picture N */
                        cgm_skipdata();
                        if( gotoPicN(PicN) != PicN)
                        {
                           fprintf(out,"\n << No picture %d >>\n",PicN);
                           cgm_done = 1;
                           break;
                        }
                        
                     }
                     cgm_read_string(); 
                     fprintf(out," \"%s\"",cgm_cbuffer);
                        if(mfList == 0)
                        fprintf(out,"\n << Missing Metafile Element List >>\n");


                     break;

             case 4: /*Begin Picture Body*/ 
                     if(state != 3)
                        fprintf(out," %s (%d)",badstate,state);
                     state = 4;
                     break;
 
             case 5: /*End Picture*/
                     if(state != 4)
                        fprintf(out," %s (%d)",badstate,state);
                     state = 5;
                     if(PicN > -1) cgm_done = 1;
                     break;

        }
    }
    else
    {   /* Metafile Descriptor Elements */
        if ( (cgm_header.id <= MAXCLASS1ID) && (cgm_header.id > -1 ) )
           fprintf(out,"\n%s",Class1[cgm_header.id]);
        else
           fprintf(out,
           "\n    %s  (%d,%d)",badel,cgm_header.class,cgm_header.id);
        if(state != 2)
           fprintf(out," %s (%d)",badstate,state);

        switch (cgm_header.id)
        {

             case 1:  /* Metafile Version*/

                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();  
                     fprintf(out," %d",p1);
                     if(p1 != 1)
                        fprintf(out," %s",nsup);
                     break;

             case 2:  /*Metafile Description*/
                     if( cgm_header.length < 1)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     cgm_read_string();
                     fprintf(out," \"%s\"",cgm_cbuffer);
                     break;

             case 3: /*VDC type */

                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();
                     if ( (p1 == 0) || (p1 == 1) )
                     {
                         fprintf(out," %s",mathtype[p1]);
                         if (p1 == 1)
                            fprintf(out," %s",nsup);
                     }
                     else
                         fprintf(out," %s (%d) ",badvalue,p1);
                     break;

             case 4: /* Integer Precision*/                              

                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();
                     switch(p1)
                     {
                          case 8:
                          case 24:
                          case 32:
                                  fprintf(out," %d-Bit %s",p1,nsup);
                                  break;
                          case 16:
                                  fprintf(out," %d-Bit",p1);
                                  break;
                          default:
                                  fprintf(out," %d-Bit %s",p1,badvalue);
                                  break;
                     }
                     break;

             case 5: /* Real Precision*/

                     if( cgm_header.length < 6)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }
                     p1 = cgm_oneival();  /* type */
                     p2 = cgm_oneival();  /* whole part */
                     p3 = cgm_oneival();  /* factional part */
                     p4 = p2 + p3;
                     switch(p1)
                     {
                         case 0:
                                fprintf(out,
                                " %d-Bit %s %s",p4,realtype[0],nsup);
                                break;
                         case 1:
                                fprintf(out," %d-Bit %s",p4,realtype[1]);
                                if ( (p2 == 16) && (p3 == 16) )
                                    break; /* ok */
                                if( (p2 == 32) && (p3 == 32) )
                                   fprintf(out," %s (%d.%d) ",nsup,p2,p3);
                                else 
                                   fprintf(out," %s",badvalue);
                                break;
                         default:
                                fprintf(out,
                                " %s (%d,%d.%d)",badvalue,p1,p2,p3);
                     };
                     break;

             case 6: /* Index Precision*/
                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();
                     fprintf(out," %d-Bit",p1);
                     if (p1 != 16)
                         fprintf(out," %s",nsup);
                     break;

             case 7: /*Color Precision*/
                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();
                     fprintf(out," %d-Bit",p1);
                     if (p1 == 16)
                        cgm_color_precision = 16;
                     else if (p1 == 8)
                        cgm_color_precision = 8;
                     else
                         fprintf(out," %s",nsup);
                     break;


             case 8: /*Color Index Precision*/

                     if( cgm_header.length < 2)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }

                     p1 = cgm_oneival();
                     fprintf(out," %d-Bit",p1);
                     if (p1 == 16)
                        cgm_color_index_precision = 16;
                     else if (p1 == 8)
                        cgm_color_index_precision = 8;
                     else
                         fprintf(out," %s",nsup);
                     break;

             case 9: /*Maximum Color Index*/
                     p1 = cgm_read_color_index();

                     if( p1 < 0)
                     {
                        fprintf(out," %s",blen);
                        break;
                     }
                     fprintf(out," %d",p1);                     
                     break;

            case 10: /*Color Value Extent*/

                     if(cgm_read_rgb_color(rgb) < 0)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }
 
                    fprintf(out," Minimum {%d,%d,%d},",rgb[0],rgb[1],rgb[2]);

                    if(cgm_read_rgb_color(rgb) < 0)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }
 
                     fprintf(out," Maximum {%d,%d,%d}",rgb[0],rgb[1],rgb[2]);
                     break;

            case 11: /* Metafile Element List*/

                     if( cgm_header.length < 6)
                     {
                         fprintf(out," %s",blen);
                         break;
                     }
                     mfList = 1;

                     p1 = cgm_oneival();
                     fprintf(out,"\n  Number in List %d",p1);
                     while (1)
                     {
                         p1 = cgm_oneival();
                         p2 = cgm_oneival();
                         set_look_up(p1,p2);
                         switch(p1)
                         {
                             case -1:
                                     if (p2 == 0)
                                        fprintf(out,"\n    DRW Set");
                                     else if (p2 == 1)
                                        fprintf(out,"\n    DRW + CNTRL Set");
                                     else
                                        fprintf(out,"\n    %s",badel);
                                     break;
                              case 0: 
                                     el_list(p1,p2,0,5,Class0);
                                     break;
                              case 1:
                                     el_list(p1,p2,1,15,Class1);
                                     break;
                              case 2:
                                     el_list(p1,p2,1,7,Class2);
                                     break;
                              case 3:
                                     el_list(p1,p2,1,6,Class3);
                                     break;
                              case 4:
                                     el_list(p1,p2,1,19,Class4);
                                     break;

                              case 5:
                                     el_list(p1,p2,1,35,Class5);
                                     break;

                              case 6:
                                     el_list(p1,p2,1,1,Class6);
                                     break;
                              case 7:
                                     el_list(p1,p2,1,2,Class7);
                                     break;
                             default:
                                     fprintf(out,
                                     "\n    Bad Class (%d,%d)",p1,p2);

                         };

                         if(cgm_header.length < 4)
                         {
                             if (cgm_header.length > 0)
                             {
                                 fprintf(out," %s",blen);
                                 break;
                             }
                             if (cgm_header.partition)
                             {
                                 cgm_header.length = _cgm_oneival();
                                 if (cgm_header.length & 0x8000)
                                     cgm_header.length &= 0x7FFF;
                                 else
                                     cgm_header.partition = 0;
                             }
                             else
                                 break;

                         }
                     }
                     break;

           case 12: /* Defaults Replacement  */
                     fprintf(out," %s",nsup);
                     break;


           case 13: /* Font List*/
                     while ( cgm_header.length > 1)
                     {
                         fprintf(out,"\n   ");
                         cgm_read_string();
                         fprintf(out,"   \"%s\"",cgm_cbuffer);
                     }
                     break;
        
           case 14: /* Character Set List*/
                    while(cgm_header.length > 2)
                    {
                        p1 = cgm_oneival();
                        if(p1 < 0)
                           fprintf(out,"\n   private (%d)  ",p1);
                        else if(p1 <= 4)
                           fprintf(out,"\n   %s  ",charsettype[p1]);
                        else
                           fprintf(out,"\n   bad type (%d)  ",p1);
                        cgm_read_string();
                        fprintf(out,"   \"%s\"",cgm_cbuffer);
                    }
                    break;


           case 15: /* Character Coding Announcer */
                    if( cgm_header.length < 2)
                    {
                        fprintf(out," %s",blen);
                        break;
                    }
                    p1 = cgm_oneival();
                    if(p1 < 0)
                        fprintf(out,"  private (%d)",p1);
                    else if(p1 <= 3)
                        fprintf(out,"  %s",charcoding[p1]);
                    else
                        fprintf(out,"  bad value (%d)",p1);
                    break;

        }

    }

}




