/********************************** pars23.c ********************************/

#include <stdio.h>
#include "cgmparse.h"
#include "chkcgm.h"

int LineScaleMode;
int EdgeScaleMode;
int MarkerScaleMode;

static char *blen = "<<* Too Few Bytes *>>";
static char *nsup = "<<* Not Supported *>>";
static char *badstate = "<<* Bad State *>>";
static char *badvalue = "<<* Unknown Value *>>";
static char *realtype[] = {"Floating Point","Fixed Point"};


char *Class2[] = { "<<* Bad ID *>>",
                   "Scaling Mode",
                   "Color Selection Mode",
                   "Line Width Specification Mode",
                   "Marker Size Specification Mode",
                   "Edge Width Specification Mode",
                   "VDC Extent",
                   "Background Color"
                 };


char *Class3[] = { "<<* Bad ID *>>",
                   "VDC Integer Precision",
                   "VDC Real Precision",
                   "Auxiliary Color",
                   "Transparency",
                   "Clip Rectangle",
                   "Clip Indicator"
                 };

void cgm_pars23(void)
{
     int p1,p2,p3,p4,rgb[3];
     long r;
     if (cgm_header.class == 2)
     {

            if ( (cgm_header.id <= MAXCLASS2ID) && (cgm_header.id > 0) )
            {
                fprintf(out,"\n%s",Class2[cgm_header.id]);
                if (!get_look_up(cgm_header.class,cgm_header.id) && mfList )
                   fprintf(out," <<* Not in Metafile Elements List *>>");
            }
             else
                fprintf(out,"\n Class 2 , ID Error (%d)",cgm_header.id);
            if (state != 3)
               fprintf(out," %s",badstate);
                 switch(cgm_header.id)
                 {
                    case 1: /* scaling mode */
                         if( cgm_header.length < 6)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }
                         p1 = cgm_oneival();
                         r = cgm_onerval();
                         if(p1 == 0)
                            fprintf(out," Abstract");
                         else if (p1 == 1)
                         {
                            fprintf(out," Metric %f",FixedtoFloat(r));
                         }
                         else
                            fprintf(out," %s (%d)",badvalue,p1);
                         break;

                    case 2: /* color selection mode */

                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if(p1 == 0)
                         {
                            fprintf(out," Indexed");
                            cgm_color_mode_in = 0;
                         }

                         else if (p1 == 1)
                         {
                            fprintf(out," Direct");
                            cgm_color_mode_in = 1;
                         }
                         else
                            fprintf(out," %s (%d)",badvalue,p1);
                         break;

                    case 3:  /* Line width specification mode */
                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if(p1 == 0)
                         {
                            fprintf(out," Absolute");
                            LineScaleMode = 0;
                         }
                         else if (p1 == 1)
                         {
                            fprintf(out," Scaled");
                            LineScaleMode = 1;
                         }
                         else
                            fprintf(out," %s (%d)",badvalue,p1);
                         break;


                    case 4: /* Marker Size specification mode */
                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if(p1 == 0)
                         {
                            fprintf(out," Absolute");
                            MarkerScaleMode = 0;
                         }
                         else if (p1 == 1)
                         {
                            fprintf(out," Scaled");
                            MarkerScaleMode = 1;
                         }
                         else
                            fprintf(out," %s (%d)",badvalue,p1);

                         break;


                    case 5: /* Edge width specification mode */

                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if(p1 == 0)
                         {
                            fprintf(out," Absolute");
                            EdgeScaleMode = 0;
                         }
                         else if (p1 == 1)
                         {
                            fprintf(out," Scaled");
                            EdgeScaleMode = 1;
                         }
                         else
                            fprintf(out," %s (%d)",badvalue,p1);
                         break;

                    case 6:  /* VDC Extent */

                         if( cgm_header.length < 8)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();   /* lower left x */
                         p2 = cgm_oneival();   /* lower left y */
                         p3 = cgm_oneival();   /* upper right x */
                         p4 = cgm_oneival();   /* upper right y */
                         fprintf(out," Lower Left Corner (%d,%d)",
                                 p1,p2);
                         fprintf(out," Upper Right Corner (%d,%d)",
                                 p3,p4);
                         break;


                    case 7:  /* backgound color */
                         if(cgm_read_rgb_color(rgb) < 0)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }
                         fprintf(out," {%d,%d,%d}",rgb[0],rgb[1],rgb[2]);
                         break;

                 };
       }
       else
       {
            if ( (cgm_header.id <= MAXCLASS3ID) && (cgm_header.id > 0) )
            {
                fprintf(out,"\n%s",Class3[cgm_header.id]);
                if (!get_look_up(cgm_header.class,cgm_header.id) && mfList)
                   fprintf(out," <<* Not in Metafile Elements List *>>");

            }
             else
                fprintf(out,"\n Class 3 , ID Error (%d)",cgm_header.id);
            if (state != 4)
               fprintf(out," %s",badstate);

              switch(cgm_header.id)
             {
                 case 1: /* VDC Integer Precision */

                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         fprintf(out," %d-bit",p1);
                         switch(p1)
                         {
 
                            case 16:
                                 break;
                            case 24:
                            case 32:
                                 fprintf(out," %s",nsup);
                                 break;
                            default:
                                 fprintf(out," %s",badvalue);
                         }
                         break;
                 case 2: /* VDC Real Precision */

                         if( cgm_header.length < 6)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();   /* type */
                         p2 = cgm_oneival();   /* whole part */
                         p3 = cgm_oneival();   /* fractional part */
                         switch(p1)
                         {
                             case 0:
                             case 1:
                                fprintf(out," %s %s (%d,%d)",
                                         realtype[p1],nsup,p2,p3);
                                break;
                             default:
                                fprintf(out," %s",badvalue);
                         };
                         break;

                 case 3: /* Auxilary Color */

                         if ( cgm_color_mode_in == 1)
                         { /* direct */
                             if( cgm_read_rgb_color(rgb) < 0)
                             {
                                 fprintf(out," %s",blen);
                                 break;
                             }
                             fprintf(out," {%d,%d,%d}",rgb[0],rgb[1],rgb[2]);
                         }
                         else
                         {  /* index */
                             p1 = cgm_read_color_index(); 
                             if( p1 < 0)
                             {
                                 fprintf(out," %s",blen);
                                 break;
                             }             
                             fprintf(out," %d",p1);
                         }
                         break;

                 case 4: /*Transparency*/
                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if(p1 == 0)
                            fprintf(out," Off");
                         else if (p1 == 1)
                            fprintf(out," On");
                         else
                            fprintf(out," %s",badvalue);
                         break;
        
                 case 5: /*Clip Rectangle*/

                         if( cgm_header.length < 8)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();  /* x1 */
                         p2 = cgm_oneival();  /* y1 */
                         p3 = cgm_oneival();  /* x2 */
                         p4 = cgm_oneival();  /* y2 */
                         fprintf(out," (%d,%d) (%d,%d)", p1,p2,p3,p4);
                         break;

                 case 6: /*Clip Indicator*/

                         if( cgm_header.length < 2)
                         {
                             fprintf(out," %s",blen);
                             break;
                         }

                         p1 = cgm_oneival();
                         if (p1 == 0)
                            fprintf(out," Off");
                         else if (p1 == 1)
                            fprintf(out," On");
                         else
                            fprintf(out," %s",badvalue);
                         break; 
             }
       }
}






